/***********************************************
/gen auto by zuitools
***********************************************/
#ifndef __MAINACTIVITY_H__
#define __MAINACTIVITY_H__


#include "app/Activity.h"
#include "entry/EasyUIContext.h"

#include "uart/ProtocolData.h"
#include "uart/ProtocolParser.h"

#include "utils/Log.h"
#include "control/ZKDigitalClock.h"
#include "control/ZKButton.h"
#include "control/ZKCircleBar.h"
#include "control/ZKDiagram.h"
#include "control/ZKListView.h"
#include "control/ZKPointer.h"
#include "control/ZKQRCode.h"
#include "control/ZKTextView.h"
#include "control/ZKSeekBar.h"
#include "control/ZKEditText.h"
#include "control/ZKVideoView.h"
#include "window/ZKSlideWindow.h"

/*TAG:Macro宏ID*/
#define ID_MAIN_SeekBar1    91001
#define ID_MAIN_Button36    20036
#define ID_MAIN_Window13    110025
#define ID_MAIN_Button35    20035
#define ID_MAIN_Window12    110024
#define ID_MAIN_Button34    20034
#define ID_MAIN_Window10    110023
#define ID_MAIN_Button33    20033
#define ID_MAIN_Window9    110022
#define ID_MAIN_Button32    20032
#define ID_MAIN_Button31    20031
#define ID_MAIN_Button30    20030
#define ID_MAIN_Button29    20029
#define ID_MAIN_Button28    20028
#define ID_MAIN_Window8    110021
#define ID_MAIN_Button27    20027
#define ID_MAIN_Window7    110020
#define ID_MAIN_Button26    20026
#define ID_MAIN_Window6    110019
#define ID_MAIN_Button25    20025
#define ID_MAIN_Window5    110018
#define ID_MAIN_Button24    20024
#define ID_MAIN_Button23    20023
#define ID_MAIN_Button22    20022
#define ID_MAIN_Window4    110017
#define ID_MAIN_Button21    20021
#define ID_MAIN_Window3    110016
#define ID_MAIN_Button20    20020
#define ID_MAIN_Window2    110015
#define ID_MAIN_Button19    20019
#define ID_MAIN_Window1    110014
#define ID_MAIN_Button18    20018
#define ID_MAIN_Button17    20017
#define ID_MAIN_Button16    20016
#define ID_MAIN_Button12    20012
#define ID_MAIN_Button11    20011
#define ID_MAIN_Button10    20010
#define ID_MAIN_Button9    20009
#define ID_MAIN_Button15    20015
#define ID_MAIN_WindowDD    110013
#define ID_MAIN_Button14    20014
#define ID_MAIN_WindowTG    110012
#define ID_MAIN_Button13    20013
#define ID_MAIN_WindowKT    110011
#define ID_MAIN_WindowWS    110010
#define ID_MAIN_TextviewAnimation    50002
#define ID_MAIN_Button8    20008
#define ID_MAIN_Button7    20007
#define ID_MAIN_Button6    20006
#define ID_MAIN_Button5    20005
#define ID_MAIN_Button4    20004
#define ID_MAIN_Button3    20003
#define ID_MAIN_Button2    20002
#define ID_MAIN_Button1    20001
#define ID_MAIN_TextViewgif    50001
#define ID_MAIN_Window88    110009
#define ID_MAIN_Window77    110008
#define ID_MAIN_Window66    110007
#define ID_MAIN_Window55    110006
#define ID_MAIN_Window44    110005
#define ID_MAIN_Window33    110004
#define ID_MAIN_Window22    110003
#define ID_MAIN_Window11    110002
#define ID_MAIN_WindowXX    110001
/*TAG:Macro宏ID END*/

class mainActivity : public Activity, 
                     public ZKSeekBar::ISeekBarChangeListener, 
                     public ZKListView::IItemClickListener,
                     public ZKListView::AbsListAdapter,
                     public ZKSlideWindow::ISlideItemClickListener,
                     public EasyUIContext::ITouchListener,
                     public ZKEditText::ITextChangeListener,
                     public ZKVideoView::IVideoPlayerMessageListener
{
public:
    mainActivity();
    virtual ~mainActivity();

    /**
     * 注册定时器
     */
	void registerUserTimer(int id, int time);
	/**
	 * 取消定时器
	 */
	void unregisterUserTimer(int id);
	/**
	 * 重置定时器
	 */
	void resetUserTimer(int id, int time);

protected:
    /*TAG:PROTECTED_FUNCTION*/
    virtual const char* getAppName() const;
    virtual void onCreate();
    virtual void onClick(ZKBase *pBase);
    virtual void onResume();
    virtual void onPause();
    virtual void onIntent(const Intent *intentPtr);
    virtual bool onTimer(int id);

    virtual void onProgressChanged(ZKSeekBar *pSeekBar, int progress);

    virtual int getListItemCount(const ZKListView *pListView) const;
    virtual void obtainListItemData(ZKListView *pListView, ZKListView::ZKListItem *pListItem, int index);
    virtual void onItemClick(ZKListView *pListView, int index, int subItemIndex);

    virtual void onSlideItemClick(ZKSlideWindow *pSlideWindow, int index);

    virtual bool onTouchEvent(const MotionEvent &ev);

    virtual void onTextChanged(ZKTextView *pTextView, const string &text);

    void rigesterActivityTimer();

    virtual void onVideoPlayerMessage(ZKVideoView *pVideoView, int msg);
    void videoLoopPlayback(ZKVideoView *pVideoView, int msg, size_t callbackTabIndex);
    void startVideoLoopPlayback();
    void stopVideoLoopPlayback();
    bool parseVideoFileList(const char *pFileListPath, std::vector<string>& mediaFileList);
    int removeCharFromString(string& nString, char c);


private:
    /*TAG:PRIVATE_VARIABLE*/
    int mVideoLoopIndex;
    int mVideoLoopErrorCount;

};

#endif